import 'rxjs/add/operator/map';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { Observable } from 'rxjs/Observable';
import { ReplaySubject } from 'rxjs/ReplaySubject';
import { Subject } from 'rxjs/Subject';
import { StateConstructor } from './constructor';
import { ReduxStateSelectorSubjectType } from './selector/subject-type';
export declare class ReduxStateSelector<S = {}> {
    private expression;
    private context;
    private static readonly DELIMITER;
    private observable;
    constructor(expression: string, context?: StateConstructor);
    asObservable(): Observable<S>;
    /**
     * @deprecated
     * Use asObservable instead
     */
    getObservable<S>(): Observable<S>;
    /**
     * @deprecated This method will be removed
     */
    getBehaviorSubject<S>(initialValue: S): BehaviorSubject<S>;
    /**
     * @deprecated This method will be removed
     */
    getReplaySubject<S>(): ReplaySubject<S>;
    /**
     * @deprecated This method will be removed
     */
    getSubject<S>(): Subject<S>;
    /**
     * @deprecated This method will be removed
     */
    getBySubjectType<S>(type: ReduxStateSelectorSubjectType, initialValue?: S): ReplaySubject<S> | Subject<S> | BehaviorSubject<S>;
    getValueFromState<T>(state: {}): T;
    private static isPropertyKeyValid(propertyKey);
}
